// Polar.java - M. Covington 1997

/*
   To accompany Astrophotography for the Amateur, 1998 edition.
   You may freely redistribute this program.
 */

import java.awt.*;
import java.applet.*;

public class Polar extends Applet {
	void textFieldT_KeyRelease(Event event) {


		//{{CONNECTION
		// Recalculate
		Recalculate();
		//}}
	}

	void textFieldHstar_KeyRelease(Event event) {


		//{{CONNECTION
		// Recalculate
		Recalculate();
		//}}
	}

	void textFieldDelta_KeyRelease(Event event) {


		//{{CONNECTION
		// Recalculate
		Recalculate();
		//}}
	}

	void textFieldHfalsepole_KeyRelease(Event event) {


		//{{CONNECTION
		// Recalculate
		Recalculate();
		//}}
	}

	void textFieldE_KeyRelease(Event event) {


		//{{CONNECTION
		// Recalculate
		Recalculate();
		//}}
	}

	void button1_Clicked(Event event) {
		//{{CONNECTION
		// (was Show the Panel; has been modified substantially)
		// Note: We do not rely on Z-order.
		// Instead we show exactly one panel at a time.
		//
		if (CalculationPanel.isVisible()) {
		  CalculationPanel.hide();
		  DocumentationPanel.show();
		  button1.setLabel("Return to program");
		}
		else {
		  DocumentationPanel.hide();
		  CalculationPanel.show();
		  button1.setLabel("Click for instructions");
		}
		//}}
	}


	public void init() {
		super.init();

		// Take out this line if you don't use symantec.itools.net.RelativeURL
    //    symantec.itools.lang.Context.setDocumentBase(getDocumentBase());

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(600,400);
		CalculationPanel = new java.awt.Panel();
		CalculationPanel.setLayout(null);
		CalculationPanel.reshape(0,48,600,350);
		CalculationPanel.setBackground(new Color(16379607));
		add(CalculationPanel);
		label2 = new java.awt.Label("Polar alignment error (degrees):",Label.RIGHT);
		label2.reshape(36,12,376,36);
		CalculationPanel.add(label2);
		label3 = new java.awt.Label("Direction of misalignment (degrees, 0=up, 90=west):",Label.RIGHT);
		label3.reshape(36,48,376,36);
		CalculationPanel.add(label3);
		label4 = new java.awt.Label("Declination of star (degrees, positive if north):",Label.RIGHT);
		label4.reshape(36,84,376,36);
		CalculationPanel.add(label4);
		label5 = new java.awt.Label("Hour angle of star (degrees, positive if west of meridian):",Label.RIGHT);
		label5.reshape(36,120,376,36);
		CalculationPanel.add(label5);
		label6 = new java.awt.Label("Exposure duration (minutes of time):",Label.RIGHT);
		label6.reshape(36,156,376,36);
		CalculationPanel.add(label6);
		label7 = new java.awt.Label("Total declination drift (arc-seconds):",Label.RIGHT);
		label7.reshape(36,192,376,36);
		CalculationPanel.add(label7);
		label8 = new java.awt.Label("Total field rotation (degrees):",Label.RIGHT);
		label8.reshape(36,228,376,36);
		CalculationPanel.add(label8);
		label9 = new java.awt.Label("Dec. drift during first minute of exposure (arc-seconds):",Label.RIGHT);
		label9.reshape(36,264,376,36);
		CalculationPanel.add(label9);
		label10 = new java.awt.Label("Field rotation during first minute of exposure (degrees):",Label.RIGHT);
		label10.reshape(36,300,376,36);
		CalculationPanel.add(label10);
		textField_e = new java.awt.TextField();
		textField_e.reshape(420,12,128,36);
		CalculationPanel.add(textField_e);
		textField_hfalsepole = new java.awt.TextField();
		textField_hfalsepole.reshape(420,48,128,36);
		CalculationPanel.add(textField_hfalsepole);
		textField_delta = new java.awt.TextField();
		textField_delta.reshape(420,84,128,36);
		CalculationPanel.add(textField_delta);
		textField_hstar = new java.awt.TextField();
		textField_hstar.reshape(420,120,128,36);
		CalculationPanel.add(textField_hstar);
		textField_t = new java.awt.TextField();
		textField_t.reshape(420,156,128,36);
		CalculationPanel.add(textField_t);
		label_decdrift = new java.awt.Label("(To be calculated)");
		label_decdrift.reshape(420,192,126,36);
		CalculationPanel.add(label_decdrift);
		label_rotation = new java.awt.Label("(To be calculated)");
		label_rotation.reshape(420,228,126,36);
		CalculationPanel.add(label_rotation);
		label_decdriftrate = new java.awt.Label("(To be calculated)");
		label_decdriftrate.reshape(420,264,126,36);
		CalculationPanel.add(label_decdriftrate);
		label_rotationrate = new java.awt.Label("(To be calculated)");
		label_rotationrate.reshape(420,300,126,36);
		CalculationPanel.add(label_rotationrate);
		label1 = new java.awt.Label("Effect of Polar Axis Misalignment - M. Covington 1997");
		label1.reshape(12,12,360,20);
		add(label1);
		button1 = new java.awt.Button("Click for instructions");
		button1.reshape(384,12,195,21);
		button1.setFont(new Font("Dialog", Font.BOLD, 12));
		add(button1);
		DocumentationPanel = new java.awt.Panel();
		DocumentationPanel.setLayout(null);
		DocumentationPanel.hide();
		DocumentationPanel.reshape(0,48,600,348);
		DocumentationPanel.setBackground(new Color(14351610));
		add(DocumentationPanel);
		DocumentationArea = new java.awt.TextArea();
		DocumentationArea.reshape(12,24,576,315);
		DocumentationPanel.add(DocumentationArea);
		//}}

		BuildInternalDocumentation();

	}

	public boolean handleEvent(Event event) {
		if (event.target == button1 && event.id == Event.ACTION_EVENT) {
			button1_Clicked(event);
			return true;
		}
		if (event.target == textField_e && event.id == Event.KEY_RELEASE) {
			textFieldE_KeyRelease(event);
			return true;
		}
		if (event.target == textField_hfalsepole && event.id == Event.KEY_RELEASE) {
			textFieldHfalsepole_KeyRelease(event);
			return true;
		}
		if (event.target == textField_delta && event.id == Event.KEY_RELEASE) {
			textFieldDelta_KeyRelease(event);
			return true;
		}
		if (event.target == textField_hstar && event.id == Event.KEY_RELEASE) {
			textFieldHstar_KeyRelease(event);
			return true;
		}
		if (event.target == textField_t && event.id == Event.KEY_RELEASE) {
			textFieldT_KeyRelease(event);
			return true;
		}
		return super.handleEvent(event);
	}

	//{{DECLARE_CONTROLS
	java.awt.Panel CalculationPanel;
	java.awt.Label label2;
	java.awt.Label label3;
	java.awt.Label label4;
	java.awt.Label label5;
	java.awt.Label label6;
	java.awt.Label label7;
	java.awt.Label label8;
	java.awt.Label label9;
	java.awt.Label label10;
	java.awt.TextField textField_e;
	java.awt.TextField textField_hfalsepole;
	java.awt.TextField textField_delta;
	java.awt.TextField textField_hstar;
	java.awt.TextField textField_t;
	java.awt.Label label_decdrift;
	java.awt.Label label_rotation;
	java.awt.Label label_decdriftrate;
	java.awt.Label label_rotationrate;
	java.awt.Label label1;
	java.awt.Button button1;
	java.awt.Panel DocumentationPanel;
	java.awt.TextArea DocumentationArea;
	//}}

// My code follows...

  // INTERNAL DOCUMENTATION

  void doc(String s) { DocumentationArea.appendText("  " + s + "\n"); }

  void BuildInternalDocumentation() {
    doc("Effect of Polar Axis Misalignment");
    doc("Michael A. Covington - 1997 August 18\n");
    doc("When you take an astronomical photograph with a telescope whose equatorial");
    doc("mount is not perfectly aligned on the celestial pole, three things happen:\n");
    doc(" - The guide star appears to shift in right ascension;");
    doc(" - The guide star appears to shift in declination;");
    doc(" - The field rotates.\n");
    doc("The first of these is absorbed into guiding corrections that are needed for");
    doc("other reasons; this program calculates the remaining two effects.\n");
    doc("To use this program you need to know:\n");
    doc(" - The amount of misalignment, in degrees.\n");
    doc(" - The direction of the misalignment.  This is also measured in degrees, where");
    doc("    0 means up, 90 means to the west, 180 means down, and 270 means east.");
    doc("    (Imagine a circular protractor in the sky, around the pole.)\n");
    doc(" - The declination of the guide star.\n");
    doc(" - The hour angle of the guide star at the beginning of the exposure.");
    doc("    Hour angle is position relative to the meridian: 0 when the star is");
    doc("    on the meridian, 15 degrees an hour afterward, 30 degrees an hour after");
    doc("    that, and so on; negative when the star is east of the meridian.\n");
    doc(" - The duration of the exposure, in minutes of time.\n");
    doc("This program calculates the total declination shift, total field rotation,");
    doc("and the declination shift rate and field rotation rate at the beginning of");
    doc("the exposure.\n");
    doc("Maximum acceptable field rotation, for a completely sharp photograph,");
    doc("is about 0.1 degree regardless of focal length.  Maximum acceptable");
    doc("declination drift depends on how hard you want to work at guiding.\n\n");
    doc("For full information see the 1998 edition of:");
    doc("ASTROPHOTOGRAPHY FOR THE AMATEUR, by Michael A. Covington");
    doc("published by Cambridge University Press.\n");
    doc("This program copyright 1997 Michael A. Covington.");
    doc("You may redistribute this program freely in unaltered form.");
  }

  // THE COMPUTATION ITSELF

  // Library functions and constants

  double cos(double x)    { return Math.cos(x);  }
  double sin(double x)    { return Math.sin(x);  }
  double acos(double x)   { return Math.acos(x); }
  double asin(double x)   { return Math.asin(x); }
  double square(double x) { return x*x; }
  double sqrt(double x)   { return Math.sqrt(x); }
  double abs(double x)    { return Math.abs(x);  }

  double DR = 180/Math.PI;   // degrees-to-radians factor, ~57.3

  double decdrift(   // Declination drift, in arc-seconds, computed from:
    double e,        //  Polar misalignment, in degrees
    double h,        //  Hr angle of star - hr angle of false pole, degrees
    double delta,    //  Declination of star, in degrees
    double t)        //  Duration of exposure, in minutes of time
  {
    double x, y, z;                   // local variables

    e = e/DR;                         // convert to radians
    h = h/DR;
    delta = delta/DR;
    t = (t/4)/DR;

    x = sin(delta)*cos(e);            // core of computation
    y = cos(delta)*sin(e);
    z = acos(cos(h+t)*y + x) - acos(cos(h)*y + x);

    z = z * DR * 3600;                // convert to arc-seconds
    if (abs(z) < 0.0001) z = 0.0;     // discard if too small (imprecise)
    return z;
  }

  double rotation(   // Field rotation, in degrees
    double e,        //  Polar misalignment, in degrees
    double h,        //  Hr angle of star - hr angle of false pole, degrees
    double delta,    //  Declination of star, in degrees
    double t)        //  Duration of exposure, in minutes of time
  {
    double w, x, y, z;                // local variables

    e = e/DR;                         // convert to radians
    h = h/DR;
    delta = delta/DR;
    t = (t/4)/DR;

    w = sin(e);                       // core of computation
    x = sin(delta)*cos(e);
    y = cos(delta)*w;
    z = asin(w*sin(h+t) / sqrt(1 - square(cos(h+t)*y + x)))
        - asin(w*sin(h) / sqrt(1 - square(cos(h)*y + x)));

    z = z * DR;                       // convert to degrees
    if (abs(z) < 0.0001) z = 0.0;     // discard if too small (imprecise)
    return z;
  }

  // INPUT, RECALCULATION, AND OUTPUT PROCEDURES

  void SetAllOutputFields(String s) {
    label_decdrift.setText(s);
    label_rotation.setText(s);
    label_decdriftrate.setText(s);
    label_rotationrate.setText(s);
  }

  void Recalculate() {
    double e,hfalsepole,hstar,h,delta,t;
    SetAllOutputFields("--CALCULATING--");

    // Grab numbers from input fields.  If any malformed, bail out.
    try {
      e          = new Double(textField_e.getText()).doubleValue();
      hfalsepole = new Double(textField_hfalsepole.getText()).doubleValue();
      delta      = new Double(textField_delta.getText()).doubleValue();
      hstar      = new Double(textField_hstar.getText()).doubleValue();
      t          = new Double(textField_t.getText()).doubleValue();
    }
    catch (NumberFormatException nfe) {
      SetAllOutputFields("??");
      return;
    }

    h = hstar - hfalsepole;
    label_decdrift.setText(new Double(decdrift(e,h,delta,t)).toString());
    label_rotation.setText(new Double(rotation(e,h,delta,t)).toString());
    label_decdriftrate.setText(new Double(decdrift(e,h,delta,1)).toString());
    label_rotationrate.setText(new Double(rotation(e,h,delta,1)).toString());

    return;
  }




}
